/**
 * Copyright 2010 Västra Götalandsregionen
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of version 2.1 of the GNU Lesser General Public
 *   License as published by the Free Software Foundation.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 *   Boston, MA 02111-1307  USA
 */

package se.vgregion.web.appx;

import java.util.Arrays;

import org.apache.commons.codec.binary.Base64;

import se.vgregion.dao.domain.patterns.entity.AbstractEntity;
import se.vgregion.signera.signature._1.SignatureFormat;

public class Signature extends AbstractEntity<Integer> {
    private byte[] signature;
    private SignatureFormat format;

    /**
     * Constructor.
     *
     * @param signature signature
     * @param format format
     */
    public Signature(byte[] signature, SignatureFormat format) {
        this.signature = signature.clone();
        this.format = format;
    }

    public Integer getId() {
        return Arrays.hashCode(signature);
    }

    public String getDecoded() {
        return new String(Base64.decodeBase64(signature));
    }
    
    public String getEncoded() {
        return new String(signature);
    }

    public SignatureFormat getFormat() {
        return format;
    }

    @Override
    public String toString() {
        return new String(signature);
    }
}